#include "Arduino.h"
#include "I2Cdev.h"
#include "Wire.h"
#include "WiFi.h"
#include "HTTPClient.h"
#include "ArduinoJson.h"
#include "ESP32Servo.h"

// Wifi Connect
const char* ssid = "Ryu" ;
const char* password  = "ryu04012001" ;
const char* urlget = "https://smart-bin-controller-server.herokuapp.com/";
const char* urlget_mov_0 = "https://smart-bin-controller-server.herokuapp.com/moving?state=0";
const char* urlget_mov_1 = "https://smart-bin-controller-server.herokuapp.com/moving?state=1&setspeed=100";
const char* urlget_set_spd = "https://smart-bin-controller-server.herokuapp.com/setspeed=100";
const char* urlget_spd_inc = "https://smart-bin-controller-server.herokuapp.com/setspeed?state=increase";
const char* urlget_spd_right = "https://smart-bin-controller-server.herokuapp.com/turn?left=0&right=1";
const char* urlget_spd_dec = "https://smart-bin-controller-server.herokuapp.com/setspeed?state=decrease";

// Assign switch
const int SW_1 = 12 ;
const int SW_2 = 14 ;
const int SW_3 = 27 ;

StaticJsonDocument<2*JSON_OBJECT_SIZE(5)> JSONGet;

// assign get method
int isMoving ;
int _speed ;
HTTPClient  http ;

int mov_state = 0 ;

void WiFi_Connect() ;
void _get() ;

void setup() 
{
  Serial.begin(115200);
  pinMode(SW_1, INPUT);
  pinMode(SW_2, INPUT);
  pinMode(SW_3, INPUT);

  delay(4000) ; 

  // Connect to Wi-Fi
  WiFi.begin(ssid , password) ; 
  while(WiFi.status() != WL_CONNECTED) 
  {
    delay(1000) ;
    Serial.println("Connecting to WiFi...") ;
  }

  // Connected
  Serial.println("Connected to the WiFi network") ;
}

void loop() 
{
  _get() ;
  if(digitalRead(SW_1) == LOW)
  {
    Serial.println("button 1 is pressed");
    if(mov_state == 0)
    {
      http.begin(urlget_mov_1) ;
      http.GET() ;
      mov_state = 1 ;
      _speed = 100 ;
      Serial.print("MOVE = ") ;
      Serial.println(mov_state) ;  
    }
    else
    {
      http.begin(urlget_mov_0) ;
      http.GET() ;
      mov_state = 0 ;
      Serial.print("MOVE = ") ;
      Serial.println(mov_state) ;      
    }
  }
  
  if(digitalRead(SW_2) == LOW)
  {
    Serial.println("button 2 is pressed");
    if(_speed == 0)
    {
      http.begin(urlget_set_spd) ;
      http.GET() ;
      _speed = 100 ;
      Serial.print(" SET SPEED 100 ") ;
    }
    if(_speed == 200)
    {
    //http.begin(urlget_spd_left) ;
    //http.GET() ;
    _speed = 200 ;
    Serial.print(" SPEED IS MAX ! ") ;  
    }
    else if(_speed == 150)
    {
    http.begin(urlget_spd_inc) ;
    http.GET() ;
    _speed = 200 ;
    Serial.print(" SET SPEED TO 200 ! ") ;  
    }
    else if(_speed == 100)
    {
    http.begin(urlget_spd_inc) ;
    http.GET() ;
    _speed = 150 ;
    Serial.print(" SET SPEED TO 150 ! ") ;  
    }
  /*else
  {
    http.begin(urlget_spd_left) ;
    http.GET() ;
    left_state = 0 ;
    Serial.print(" GO STRAIGHT ") ;       
  }*/
  }
  if(digitalRead(SW_3) == LOW)
  {
    Serial.println("button 3 is pressed");
    if(_speed == 100)
    {
    Serial.println(" SPEED IS MIN ! ") ;  
    }
    else if(_speed == 150)
    {
    http.begin(urlget_spd_dec) ;
    http.GET() ;
    _speed = 100 ;
    Serial.print(" SET SPEED TO 100 ! ") ;  
    }
    else if(_speed == 200)
    {
    http.begin(urlget_spd_dec) ;
    http.GET() ;
    _speed = 150 ;
    Serial.print(" SET SPEED TO 150 ! ") ;  
    }
  }
  delay(200) ;  
}

void  WiFi_Connect() 
{
  WiFi.disconnect() ;
  WiFi.begin(ssid , password) ;

  while (WiFi.status() != WL_CONNECTED) {
    delay(1000) ;
    Serial.println("Connecting to WiFi...") ;
  }
  Serial.println("Conneccted to the WiFi network") ;
  Serial.print("IP Address: ") ;
  Serial.println(WiFi.localIP()) ;
}

void _get() {
  if (WiFi.status() == WL_CONNECTED) {
    // HTTPClient  http ;

    http.begin(urlget) ;

    int httpCode = http.GET() ;

    if (httpCode == HTTP_CODE_OK) {
      String payload = http.getString() ;
      DeserializationError err = deserializeJson(JSONGet , payload) ;
      if (err) 
      {
        Serial.print(F("deseaializeJson() failed with code: ")) ;
        Serial.println(err.c_str()) ;
      } 
      else 
      {
        isMoving = (int)JSONGet["moving_status"];
        _speed = (int)JSONGet["speed_status"]; 
        //left_state = (int)JSONGet["left_status"]; 
        //right_state = (int)JSONGet["right_status"];     
        Serial.print("httpCode: ") ;
        Serial.println(httpCode);
        Serial.println(payload);
        Serial.println(isMoving) ;
        Serial.println(_speed) ;
        //Serial.println(left_state) ;
        //Serial.println(right_state) ;
      }
    } 
    else 
    {
      Serial.println(httpCode) ; 
      Serial.println("ERROR on HTTP Request") ;
    }
  } 
  else 
  {
    WiFi_Connect() ;
  }
}
