#include "Arduino.h"
#include "I2Cdev.h"
#include "Wire.h"
#include "WiFi.h"
#include "HTTPClient.h"
#include "ArduinoJson.h"
#include "ESP32Servo.h"

// Board 1 Servo and Ultrasonic
Servo myservo ;

const int Echo = 33 ;
const int Trigger = 5 ;

void setup() 
{
  pinMode(Echo, INPUT) ;
  pinMode(Trigger, OUTPUT) ;
  Serial.begin(9600) ;
  myservo.attach(27) ;
  myservo.write(0) ;
}

void loop()
{
  
  long duration , cm ;
  digitalWrite(Trigger, LOW) ;
  delayMicroseconds(5) ;
  digitalWrite(Trigger, HIGH) ;
  delayMicroseconds(5) ;
  digitalWrite(Trigger, LOW) ; 
  
  duration = pulseIn(Echo, HIGH) ;
  Serial.println(duration) ;
  cm = microsecondsToCentimeters(duration) ;
  Serial.print(cm) ;
  Serial.print(" cm") ;
  Serial.println() ;

  if (cm <= 10)
  {
    myservo.write(90) ;
    Serial.print("OPEN KRUB !!") ;
    Serial.println() ;
    delay(5000) ;
    myservo.write(0) ;
  }
  delay(500) ;
}

long microsecondsToCentimeters(long microseconds)
{
// The speed of sound is 340 m/s or 29 microseconds per centimeter.
// The ping travels out and back, so to find the distance of the
// object we take half of the distance travelled.
  return microseconds / 29 / 2;
}
