#include <mbed.h>

DigitalOut led(D13);
DigitalIn sw(D3, PullUp);
I2CSlave slave(D4, D5);

int main() {

  DigitalOut ledpins[10] = {D12, D11, D13, D3, D6, D9, D10, D1, D0, D2};
  //
  // ส่งข้อมูลไปหา ESP32
  char buf[20];

  printf("STM32 started...\n");
  slave.address(0xA0); // actual address = 0x50 (last bit ignored)
  while (1) {
    // ส่งข้อมูลไปหา ESP32
    int i = slave.receive();

    for (int i = 0; i < sizeof(buf); i++)
      buf[i] = 0; // Clear buffer
    switch (i) {
    case I2CSlave::ReadAddressed:
      // }
      slave.write("Smart bin", 9);

      break;
    case I2CSlave::WriteAddressed:
      slave.read(buf, sizeof(buf) - 1);
      int percent_height = atoi(buf);

      printf("Read: %s = %d\n", buf, percent_height);

      // reset all LED
      for (int i = 0; i < 10; i++) {
        ledpins[i] = 0;
      }
      // success
      if (percent_height != -1) {
        for (int i = 0; i < 10; i++) {
          if (percent_height == i) {
            for (int j = 0; j < 10; j++) {
              if (j <= i) {
                ledpins[j] = 1;
              } else {
                ledpins[j] = 0;
              }
            }
          }
        }
        // fail
      } else {
        for (int i = 0; i < 10; i++) {
          ledpins[i] = !ledpins[i];
          ThisThread::sleep_for(100ms);
        }
      }
    }
  }
}
