import time
from machine import Pin, I2C
import ssd1306

from hcsr04 import HCSR04
from time import sleep

# height of smart bin
HEIGHT = 30

i2c = I2C(scl=Pin(22),sda=Pin(21))
ult_sensor = HCSR04(trigger_pin=5, echo_pin=33, echo_timeout_us=10000)

oled_width = 128
oled_height = 64
oled = ssd1306.SSD1306_I2C(oled_width, oled_height, i2c)
#oled.invert(True)

print("Scanning I2C bus... found",i2c.scan())
time.sleep(0.5)
print("Send data to STM32...")
i2c.writeto(0x50, b'Hello from ESP32')

while True:
    
    time.sleep(1.0)
    distance = ult_sensor.distance_cm()
    percent_hight = (HEIGHT - int(distance)) * (100/HEIGHT)
    
    oled.fill(0)
    oled.text("SmartBin Project", 0, 0)
    #oled.text("Beta version",0, 10)
    oled.text("Bin Capacity", 0, 20)
    
    if distance > HEIGHT and percent_hight < 0:
        percent_hight = 0
        distance = HEIGHT
        print("Too far to detect. "+"("+str(HEIGHT)+"cm)")
        i2c.writeto(0x50, str("-1"))   
        oled.text("Trash lid is open", 0, 40)
        #print("Not detect")
    else:
        print('Distance:', int(distance), 'cm')
        i2c.writeto(0x50, str(percent_hight//10))
        oled.text(str(HEIGHT - int(distance))+"/30 CM", 0, 40)
        oled.text("percent : " + str(int(percent_hight))+"%", 0, 50)

    oled.show()
    print(percent_hight//10)